#!/usr/bin/python

program_name = "pydb"
program_version = "0.2"

import sqlite
from gtk import *
from pydbwidgets import *

#
# cnx = connect('db')
# c = cnx.cursor()
# c.execute('pysqlite_pragma expected_types = int,str,int,float')
# c.execute('select * from plants')
# cnx.commit()
# cnx.close()
# 

#
# TODO:
# * no database open window..  open one
# + table selector window
#   - table creator dialog
# - table schema editor
#   - column creator dialog
#   - does sqlite support "alter table"?
# - column type editor
# + table data editor window
#   * view data
#   - figure out how to uniquely identify each row to sqlite
#     - ... row ID numbers?
#     - how does phpmyadmin work?
#   - edit row
#   - edit cell (popup, edit-in-place, etc)
#   - filter editor
#   - sort by column heading
# - column datatypes...
#   - text
#   - int
#   - float
#   - date/time
#   - checkbox
#   - pop-up
#     - implement as table_column_values "movie_genre_popups"
#   - calculated...
#

def gtkmain(*args):
  mainloop()

def runqueue(*args):
  while events_pending():
    mainiteration()

def sql_escape(text):
  import string

  text = string.replace(text, "'", "''")
  return text

class row_edit_window:
  def __init__(self, parent, row, col=None):
    self.parent = parent
    self.row = row
    self.col = col

    self._make_frame()

  def _make_frame(self):
    f = self.parent.parent._row_edit_frame

    for c in f.children():
      f.remove(c)

    v = GtkVBox()
    f.add(v)

    self._make_data_frame(v)

    h = GtkHBox()
    v.add(h, fill=0, expand=0)

    b = GtkButton("Cancel")
    b.connect("clicked", self._cancel)
    h.add(b)

    b = GtkButton("Save")
    b.connect("clicked", self._save)
    h.add(b)

  def _make_data_frame(self, frame):
    sw = GtkScrolledWindow()
    frame.add(sw, fill=1, expand=1)

    v = GtkVBox()
    sw.add_with_viewport(v)

    if self.col:
      name = self.parent.columns[self.col].name
      datatype = self.parent.columns[self.col].type
      clicked, entered = EntryWindow("Edit Cell", "%s (%s)" % (name, datatype),
                                     self.row[self.col])

      #l = GtkLabel("%s (%s)" % (name, datatype))
      #v.add(l, fill=0, expand=0)
      #e = GtkEntry()
      #e.set_text("%s" % self.row[self.col])
      #v.add(e, fill=0, expand=0)
    else:
      l = GtkLabel("Row Editor...")
      v.add(l, fill=1, expand=1)

  def run(self):
    self.parent.parent._show_frame(self.parent.parent._row_edit_frame)

  def _done(self, *args):
    self.parent.parent._show_frame(self.parent.parent._table_frame)

  def _save(self, *args):
    self._done()

  def _cancel(self, *args):
    self._done()

class column:
  def __init__(self):
    self.name = ""
    self.type = ""

  def guess_type(self):
    import string
    typemap = {
      "text" : "text",
      "int" : "int",
      "varchar" : "text",
      "float" : "float",
      "checkbox" : "checkbox",
      "boolean" : "checkbox",
      "date" : "date",
      "time" : "date",
    }
    self.type = self.type.lower()
    for k in typemap.keys():
      if self.type[:len(k)] == k:
	self.type = typemap[k]
	return

    print "Type '%s' not recognized.  Defaulting to 'text'." % (self.type)
    self.type = "text"

class table:
  def __init__(self, parent, name):
    self.parent = parent
    self.name = name
    self.columns=[]
    self.sql=""
    self.query=""
    self.rows = []
    self.row = -1
    self.col = -1
    self._sort_col = 0
    self._sort_order = ""
    self._editing_now = 0

  def guess_columns(self):
    import string
    #print "sql for %s: %s" % (self.name, self.sql)

    rid = column()
    rid.name = "rowid"
    rid.type = "int"
    self.columns = [rid]
    start = string.find(self.sql, "(")
    end = string.rfind(self.sql, ")")
    deftext = self.sql[start+1:end]
    #print "'%s'" % (deftext)
    fields = string.split(deftext, ",")
    for ftext in fields:
      ftext = string.strip(ftext)
      #print "\t'%s'" % (ftext)
      words = string.split(ftext)
      c = column()
      c.name = words[0]
      c.type = words[1]
      c.guess_type()
      self.columns.append(c)

  def make_clist(self):
    cols = len(self.columns) - 1
    cl = GtkCList(cols)
    self.clist = cl
    cl.connect("select-row", self._selrow_cb)
    cl.connect("unselect-row", self._unselrow_cb)
    cl.connect("click-column", self._selcol_cb)
    cl.set_selection_mode(SELECTION_BROWSE)
    cl.columns_autosize()
    for i in xrange(cols):
      c = self.columns[i+1]
      cl.set_column_title(i, c.name)
      cl.set_column_auto_resize(i, 1)
    cl.column_titles_show()

    self.update_clist()
    return cl

  def update_row(self, row):
    query = "select rowid, * from %s where rowid=%s" % (self.name, self.rows[row][0])
    #print "Q: %s" % (query)
    self.parent.dbc.execute(query)
    result = self.parent.dbc.fetchone()
    r = result[:]
    self.rows[row] = r

  def update_rows(self, reset=1):
    if reset  or  not self.query:
      self.query = "select rowid, * from %s order by %s %s" % (self.name, self.columns[self._sort_col].name, self._sort_order)

    #print "Q: %s" % (self.query)

    self.rows = []
    self.parent.dbc.execute(self.query)
    result = self.parent.dbc.fetchone()
    while result:
      r = result[:]
      #print "row: %s" % r
      self.rows.append(r)
      result = self.parent.dbc.fetchone()
  
  def update_clist(self):
    self.update_rows()
    self.clist.freeze()
    self.clist.clear()
    for r in self.rows:
      data = []
      for c in r[1:]:
	data.append("%s" % c)
      self.clist.append(data)
    self.clist.thaw()

  def _editrow_cb(self, col=None, *args):
    #print "editrow_cb()"
    if self._editing_now:
      return

    self._editing_now = 1
    if col > 0:
      name = self.columns[col].name
      datatype = self.columns[col].type
      row = self.rows[self.row]
      clicked, entered = EntryWindow("Edit Cell", "%s (%s)" % (name, datatype),
                                     ("", row[col]), [("Save", "save"), 
				                      ("Cancel", "cancel")],
			             transient=self.parent.win)
      if clicked == "save":
	#print "Value changed to: %s" % (entered)
	self._set_value(self.row, col, entered)
    else:
      raise "Not Implemented", "write the row editor window!"
      w = row_edit_window(self, self.rows[self.row], col)
      w.run()
      col = None
    self._editing_now = 0
    #print "editrow_cb() done"

  def _selrow_cb(self, *args):
    #print "Args: %s" % (repr(args))
    if self._editing_now:
      return
    oldrow = self.row
    oldcol = self.col
    self.row = args[1]
    self.col = args[2]
    if self.col >= 0  and  oldrow == self.row:
      #print "selrow: %s,%s" % (self.row, self.col)
      self._editrow_cb(self.col+1, args)

  def _unselrow_cb(self, *args):
    pass

  def _selcol_cb(self, *args):
    if self._sort_col == args[1] + 1:
      if self._sort_order == "desc":
	self._sort_order = ""
      else:
	self._sort_order = "desc"
    self._sort_col = args[1] + 1
    self.update_clist()

  def _set_value(self, row, col, value):
    sql = "update %s set %s='%s' where rowid=%s" % (self.name,
          self.columns[col].name, sql_escape(value), self.rows[row][0])
    self.parent.dbc.execute(sql)
    self.parent.save()

    self.update_row(row)

    d = list(self.rows[self.row])
    #print "%s: %s" % (type(d), d)
    d[col] = value
    data = []
    for item in d[1:]:
      data.append("%s" % item)
    last = len(self.rows)
    self.clist.freeze()
    self.clist.append(data)
    self.clist.swap_rows(last, self.row)
    self.clist.remove(last)
    self.clist.thaw()

class mainwin:
  def __init__(self, cfg, file=None):
    self.cfg = cfg
    self.file = file
    self.dbname = None
    self.tablename = None
    self.db = None
    self.dbc = None

    self._dbsel_frame = None
    self._db_frame = None
    self._table_frame = None
    self._row_edit_frame = None

    self._cwd = self.cfg.default_dir

    # FIXME: make this work, so ^C can kill program
    import signal
    signal.signal(signal.SIGINT, self._quit)

    self._make_window()
    self._make_dbsel_frame()
    self._make_db_frame()
    self._make_table_frame()
    self._make_row_edit_frame()
    self._show_dbsel_frame()

    if self.file:
      self.connect()
      self._update_db_frame()
      self._show_db_frame()

  def run(self, *args):
    gtkmain()
    
  def connect(self):
    print "Loading %s..." % (self.file)
    self.db = sqlite.connect(self.file, 077)
    self.dbc = self.db.cursor()
    self.update_table_list()
    self.dbname = self.file
    l = len(self.file) - 1
    while l >= 0:
      if self.file[l] == "/":
	self.dbname = self.file[l+1:]
	break
      l = l - 1
    print "Loading %s...  Done." % (self.file)

  def update_table_list(self):
    import string
    sql = "select * from sqlite_master where type in ('table') order by name"
    self.tables = []
    self.dbc.execute(sql)
    result = self.dbc.fetchone()
    while result:
      t = table(self, result['name'])
      t.name = result['name']
      t.sql = result['sql']
      t.guess_columns()
      self.tables.append(t)
      result = self.dbc.fetchone()
    for t in self.tables:
      print "Table: %s" % (t.name)
      
      sql = "select count(*) from %s" % (t.name)
      self.dbc.execute(sql)
      result = self.dbc.fetchone()
      t.num_records = result[0]

      for c in t.columns:
	print "\t%s %s" % (c.type, c.name)

  def save(self):
    if self.db:
      self.db.commit()

  def close(self):
    if self.db:
      self.db.close()
      self.db = None
      self.dbc = None

  def _show_frame(self, frame, *args):
    if self._db_frame:
      self._db_frame.hide()
    if self._table_frame:
      self._table_frame.hide()
    if self._row_edit_frame:
      self._row_edit_frame.hide()
    if self._dbsel_frame:
      self._dbsel_frame.hide()
    frame.show_all()

  def _make_window(self):
    self.win = GtkWindow()
    self.win.connect("destroy", self._quit)
    self.win.set_title("%s %s" % (program_name, program_version))
    self.win.set_default_size(self.cfg.width, self.cfg.height)
    self.winframe = GtkVBox()
    self.win.add(self.winframe)

    self.win.show_all()

  def _make_dbsel_frame(self):
    if self._dbsel_frame:
      self._dbsel_frame.show_all()
      return

    v = GtkVBox()
    self._dbsel_frame = v
    self.winframe.add(v)

    l = GtkLabel("(no database open)")
    v.add(l, fill=1, expand=1)
    
    h = GtkHBox()
    v.add(h, fill=0, expand=0)

    b = GtkButton("Open DB")
    b.connect("clicked", self._open_db)
    h.add(b)

    b = GtkButton("Quit")
    b.connect("clicked", self._quit)
    h.add(b)

    v.show_all()

  def _show_dbsel_frame(self, *args):
    self._show_frame(self._dbsel_frame)
    self.win.set_title("%s %s" % (program_name, program_version))

  def _make_db_frame(self):
    if self._db_frame:
      self._db_frame.show_all()
      return

    v = GtkVBox()
    self._db_frame = v
    self.winframe.add(v)

    l = GtkLabel("Select Table...")
    v.add(l, fill=0, expand=0)
    
    cl = GtkCList(2)
    self._db_clist = cl
    self._table_selected = -1
    cl.connect("select-row", self._db_clist_selrow_cb)
    cl.set_selection_mode(SELECTION_BROWSE)
    cl.set_column_title(0, "Table Name")
    cl.set_column_title(1, "Records")
    cl.set_column_justification(1, JUSTIFY_RIGHT)
    cl.columns_autosize()
    cl.set_column_auto_resize(0, 1)
    cl.set_column_auto_resize(1, 1)
    cl.column_titles_show()
    v.add(cl, fill=1, expand=1)

    h = GtkHBox()
    v.add(h, fill=0, expand=0)

    b = GtkButton("Open")
    b.connect("clicked", self._table_open_cb)
    h.add(b)

    b = GtkButton("(Create)")
    h.add(b)

    b = GtkButton("(Drop)")
    h.add(b)

    b = GtkButton("Close")
    b.connect("clicked", self._close_db)
    h.add(b)

    v.show_all()

  def _show_db_frame(self, *args):
    self._show_frame(self._db_frame)
    self.win.set_title("%s: %s" % (program_name, self.dbname))

  def _update_db_frame(self, *args):
    self._db_clist.clear()
    runqueue()

    self._db_clist.freeze()
    for t in self.tables:
      #print "Table: %s (%s)" % (t.name, t.num_records)
      data = [t.name, t.num_records]
      self._db_clist.append(data)
    self._db_clist.thaw()

  def _make_table_frame(self):
    if self._table_frame:
      self._table_frame.show_all()
      return

    v = GtkVBox()
    self._table_frame = v
    self.winframe.add(v)

    #self._table_holder = t
    self._table_holder = GtkScrolledWindow()
    self._old_table_cl = None
    v.add(self._table_holder, fill=1, expand=1)

    ag = GtkAccelGroup()
    itemf = GtkItemFactory(GtkMenuBar, "<main>", ag)
    itemf.create_items([
      ("/Record", None, None, 0, "<Branch>"),
      ("/Record/(Add)", None, None, 0, ""),
      ("/Record/(Delete)", None, None, 0, ""),
      ("/Record/(Delete Visible)", None, None, 0, ""),
      ("/Record/(Find)", None, None, 0, ""),
      ("/(New)", None, None, 0, ""),
      ("/Close", None, self._close_table_frame, 0, ""),
      ])
    menubar = itemf.get_widget("<main>")
    v.add(menubar, fill=1, expand=0)
    
    v.show_all()

  def _set_table_clist(self, cl):
    if self._old_table_cl:
      self._old_table_cl.unrealize()
      self._old_table_cl.hide()
      del self._old_table_cl
    #self._table_holder.attach(cl, 0,1, 0,1)
    for c in self._table_holder.children():
      self._table_holder.remove(c)
    #self._table_holder.add(cl, fill=1, expand=1)
    self._table_holder.add(cl)
    self._old_table_cl = cl

  def _show_table_frame(self, *args):
    self._show_frame(self._table_frame)
    self.win.set_title("%s: %s (%s)" % (program_name, self.table.name, self.dbname))

  def _close_table_frame(self, *args):
    self._show_db_frame()

  def _update_table_frame(self, *args):
    cl = self.table.make_clist()
    self._set_table_clist(cl)

  def _make_row_edit_frame(self):
    if self._row_edit_frame:
      self._row_edit_frame.show_all()
      return

    v = GtkVBox()
    self._row_edit_frame = v
    self.winframe.add(v)

    v.show_all()

  def _show_row_edit_frame(self, *args):
    self._show_frame(self._row_edit_frame)

  def _open_db(self, *args):
    filename = self.file_selector("Open...", "")
    if filename:
      self.file = filename
      self.connect()
      self._update_db_frame()
      self._show_db_frame()

  def _close_db(self, *args):
    #self.save()
    self.close()
    self.file = ""
    self._show_dbsel_frame()

  def file_selector(self, title, filename):
    import os.path
    self.file_selector_cb_button = None
    
    fs = GtkFileSelection(title)
    if filename:
      fs.set_filename(filename)
    else:
      fs.set_filename(self._cwd)
    fs.ok_button.connect("clicked", self.file_selector_ok_cb)
    fs.cancel_button.connect("clicked", self.file_selector_cancel_cb)
    fs.show_all()
    mainloop()

    if self.file_selector_cb_button == "ok":
      filename = fs.get_filename()
      self._cwd = "%s/" % (os.path.dirname(filename))
      fs.hide()
      return filename
    else:
      fs.hide()
      return None

  def file_selector_ok_cb(self, *args):
    #print "ok"
    self.file_selector_cb_button = "ok"
    mainquit()

  def file_selector_cancel_cb(self, *args):
    #print "cancel"
    self.file_selector_cb_button = "cancel"
    mainquit()

  def _db_clist_selrow_cb(self, *args):
    #print "Args: %s" % (repr(args))
    oldrow = self._table_selected
    self._table_selected = args[1]
    if oldrow == self._table_selected:
      self._table_open_cb()

  def _table_open_cb(self, *args):
    t = self.tables[self._table_selected]
    self.table = t
    self._update_table_frame()
    self._show_table_frame()

  def _quit(self, *args):
    #self.save()
    self.close()
    self.win.unrealize()
    self.win.hide()
    del self.win
    mainquit()

  def nop(self, *args):
    pass

def run(args):
  import pycfg
  cfg = pycfg.config(program_name)
  cfg.load()

  filename = None
  if len(args) > 0:
    filename = args[0]

  w = mainwin(cfg, filename)
  w.run()

if __name__ == "__main__":
  import sys
  i = len(sys.argv[0]) - 1
  while i >= 0:
    if sys.argv[0][i] == "/":
      #print "path add: %s" % (sys.argv[0][:i])
      sys.path.append(sys.argv[0][:i])
      break
    i = i - 1
  #print sys.argv[0]
  run(sys.argv[1:])
